exclude = {
["used-up-uranium-fuel-cell"] = true,
}
raws = {
["water"] = true
}

function sort_array_order_string(arr) --with .order_string
	local sort_arr= {}
	local new_arr={}
	local order_strings = {}
	for index,entry in pairs(arr) do
		if index ~="order_string" then
			order_strings[entry.order_string]=index
		end
	end
	local i=1
	for _,entry in pairs(arr) do
		sort_arr[i]=entry.order_string or ""
		i=i+1
	end
	table.sort(sort_arr)
	for _,index in pairs(sort_arr) do
		new_arr[order_strings[index] or "order_string"] = arr[order_strings[index] or arr.order_string]
	end
	arr = new_arr
	return arr
end
function sort_array(arr) --simple table.sort but with string indexes
	local sort_arr= {}
	local new_arr={}
	local order_strings = {}
	for index,entry in pairs(arr) do
		order_strings[entry]=index
	end
	local i=1
	for _,entry in pairs(arr) do
		sort_arr[i]=entry
		i=i+1
	end
	table.sort(sort_arr)
	for _,index in pairs(sort_arr) do
		new_arr[order_strings[index]] = arr[order_strings[index]]
	end
	arr = new_arr
	return arr
end

function create_database()
	global.database = {}
	global.itemselector = {}
	global.totaldemand = {}
	local order_string_fix = 1
	for recipe_name, recipe in pairs(global.recipes) do
		if not recipe.error then
			local sum = 1
			for item_name, amount in pairs(recipe.products) do
				sum=sum+amount
			end
			if sum >1 then
				sum=sum-1
			end
			for item_name, amount in pairs(recipe.products) do
				order_string_fix = order_string_fix +1
				local proto = game.item_prototypes[item_name]
				local type = "item"
				if not proto then
					proto = game.fluid_prototypes[item_name]
					type = "fluid"
				end
				if not global.itemselector[proto.group.name] then
					global.itemselector[proto.group.name] = {}
					global.itemselector[proto.group.name].order_string = proto.group.order..order_string_fix
				end
				if not global.itemselector[proto.group.name][proto.subgroup.name] then
					global.itemselector[proto.group.name][proto.subgroup.name] = {}
					global.itemselector[proto.group.name][proto.subgroup.name].order_string = proto.subgroup.order..order_string_fix
				end
				global.itemselector[proto.group.name][proto.subgroup.name][item_name] = proto.order..order_string_fix
				global.database[item_name] = {raw = recipe.raw, intermediates = recipe.intermediates or {}, type = type, recipe = recipe_name}
				if sum >1 then
					for test, amount in pairs(global.database[item_name].raw) do
						amount = amount / sum
					end
					for _, amount in pairs(global.database[item_name].intermediates) do
						amount = amount / sum
					end
				end
			end
		end
	end
	for _, tbl in pairs(global.database) do
		for item, amount in pairs(tbl.raw) do
			global.totaldemand[item] = (global.totaldemand[item] or 0) + amount
		end
		for item, amount in pairs(tbl.intermediates) do
			global.totaldemand[item] = (global.totaldemand[item] or 0) + amount
		end
	end
	for name, amount in pairs(global.totaldemand) do
		local item = game.item_prototypes[name]
		local fluid = game.fluid_prototypes[name]
		if fluid then
			global.totaldemand[name] = amount*100
			--print(name.. " -> "..amount)
		end
		if not proto then
			--print(name)
		else
			--print(proto.type)
		end
	end
	global.itemselector = sort_array_order_string(global.itemselector)
	for groupname,group in pairs(global.itemselector) do
		global.itemselector[groupname].order_string = nil
		global.itemselector[groupname] = sort_array_order_string(global.itemselector[groupname])
		for subgroupname, subgroup in pairs(global.itemselector[groupname]) do
			global.itemselector[groupname][subgroupname].order_string = nil
			global.itemselector[groupname][subgroupname] = sort_array(subgroup)
		end
	end
	--for groupname,group in pairs(global.itemselector.combat.gun) do
	--	print(groupname)
	--end
end

function rebuild_recipes()
	global.best_machine = {}
	for name, proto in pairs(game.entity_prototypes) do
		if proto.crafting_categories and proto.name ~= "player" and proto.name ~= "escape-pod-assembler" and proto.energy_usage and proto.energy_usage > 0 then
			for cat, _ in pairs(proto.crafting_categories) do
				if not global.best_machine[cat] then
					global.best_machine[cat]={speed = proto.crafting_speed or 1, energy = (proto.energy_usage or 1), name = name}
				elseif (proto.crafting_speed or 1)/(proto.energy_usage or 1) > global.best_machine[cat].speed / global.best_machine[cat].energy then
					global.best_machine[cat]={speed = proto.crafting_speed or 1, energy = (proto.energy_usage or 1), name = name}
				end
			end
		end
	end
	global.recipes = {}
	global.updaterecipes = true
	global.totalrecipes = 0
	global.updateprogress = 0
	global.pauseupdate = false
	for name, proto in pairs(game.recipe_prototypes) do
		global.totalrecipes = global.totalrecipes + 1
	end
	for _, player in pairs(game.players) do
		updatergui(player)
	end
end



function rawingredients(recipe) -- call this function
	ret = getRawIngredients(recipe,exclude)
	ret.time = (ret.time or 0)+(recipe.energy or 1)/global.best_machine[recipe.category].speed
	--ret.time = (ret.time or 0)+(recipe.energy or 1)
	ret.energy = (ret.energy or 0)+(recipe.energy or 1)/global.best_machine[recipe.category].speed*global.best_machine[recipe.category].energy
	return ret
end

function getIngredients(recipe)
	local ingredients = {}
	for i,ingredient in pairs(recipe.ingredients) do
		if (ingredient.name and ingredient.amount) then
			ingredients[ingredient.name] = ingredient.amount
		elseif (ingredient[1] and ingredient[2]) then
			ingredients[ingredient[1]] = ingredient[2]
		end
	end
	return ingredients
end

function getProducts(recipe)
	local products = {}
	if (recipe.products) then
		for i,product in pairs(recipe.products) do
			if string.sub(product.name,-6) ~="-scrap" then
				if (product.name and product.amount) then
					products[product.name] = product.amount
				elseif product.amount_min and product.amount_max then
					products[product.name] =  (product.amount_min+product.amount_max)/2 * (product.probability or 1)
				end
			end
		end
	end
	return products
end

function getRecipes(item)
	local recipes = {}
	for i,recipe in pairs(game.recipe_prototypes) do
		if i ~="coal-liquefaction" and not (string.sub(item,-7) ~= "-barrel" and string.sub(i,-7) == "-barrel" and (string.sub(i,1,5) == "fill-" or string.sub(i,1,6) == "empty-")) then
			local products = getProducts(recipe)
			for product,amount in pairs(products) do
				if (product == item) then
					--print(recipe.name)
					table.insert(recipes, recipe)
				end
			end
		end
	end
	return recipes
end

function getRawIngredients(recipe,excluded)
	local raw_ingredients = {
	["time"] = 0,
	["energy"] = 0}
	for name,amount in pairs(getIngredients(recipe)) do
		-- Do not use an item as its own ingredient 
		if (excluded[name]) then
			return {ERROR_INFINITE_LOOP = name}
		end
		local excluded_ingredients = {[name] = true}
		for k,v in pairs(excluded) do
			excluded_ingredients[k] = true
		end

		-- Recursively find the sub-ingredients for each ingredient
		-- There might be more than one recipe to choose from
		local subrecipes = {}
		local loop_error = nil
		for i,subrecipe in pairs(getRecipes(name)) do
			local subingredients = getRawIngredients(subrecipe, excluded_ingredients)
			if (subingredients.ERROR_INFINITE_LOOP) then
				loop_error = subingredients.ERROR_INFINITE_LOOP
			else
				local value = 0
				for subproduct,subamount in pairs(getProducts(subrecipe)) do
					value = value + subamount
				end

				local divisor = 0
				for subingredient,subamount in pairs(subingredients) do
					if subingredient ~= "intermediates" then
						divisor = divisor + subamount
					end
				end

				if (divisor == 0) then divisor = 1 end

				table.insert(subrecipes, {recipe = subrecipe, ingredients = subingredients, value = value / divisor})
			end
		end
		
		if (#subrecipes == 0) or raws[name] then
			if (loop_error and loop_error ~= name) then
				-- This branch of the recipe tree is invalid
				return {ERROR_INFINITE_LOOP = loop_error}
			else
				-- This is a raw resource
				if (raw_ingredients[name]) then
					raw_ingredients[name] = raw_ingredients[name] + amount
				else 
					raw_ingredients[name] = amount
				end
				
			end
		else
			-- Pick the cheapest recipe
			local best_recipe = nil
			local best_value = 0
			for i,subrecipe in pairs(subrecipes) do
				if (best_value < subrecipe.value) then
					best_value = subrecipe.value
					best_recipe = subrecipe
				end
			end

			local multiple = 0
			for subname,subamount in pairs(getProducts(best_recipe.recipe)) do
				multiple = multiple + subamount
			end

			if not raw_ingredients["intermediates"] then raw_ingredients["intermediates"] = {} end
			for subname,subamount in pairs(best_recipe.ingredients) do
				if subname == "intermediates" then
					for a, b in pairs(subamount) do
						raw_ingredients["intermediates"][a] = (raw_ingredients["intermediates"][a] or 0)+b*amount/multiple
					end
				elseif (raw_ingredients[subname]) then
					raw_ingredients[subname] = raw_ingredients[subname] + amount * subamount / multiple
				else
					raw_ingredients[subname] = amount * subamount / multiple
				end
			end 
			for a, b in pairs(getProducts(best_recipe.recipe)) do
				raw_ingredients["intermediates"][a] = (raw_ingredients["intermediates"][a] or 0)+b*amount/multiple
			end
			raw_ingredients["time"] = raw_ingredients["time"] + (best_recipe.recipe.energy or 1)/global.best_machine[best_recipe.recipe.category].speed*amount/multiple
			--raw_ingredients["time"] = raw_ingredients["time"] + (best_recipe.recipe.energy or 1)*amount/multiple
			raw_ingredients["energy"] = raw_ingredients["energy"] + (best_recipe.recipe.energy or 1)/global.best_machine[best_recipe.recipe.category].speed*global.best_machine[best_recipe.recipe.category].energy*amount/multiple
			
		end
	end

	return raw_ingredients	
end