ITESEL_WIDTH = 800
ITESEL_HEIGHT = 600
ITESEL_COLS = 10
raw_prices = {
["crude-oil"] = 0.01,
["iron-ore"] = 0.2,
["copper-ore"] = 0.2,
["coal"] = 0.2,
["uranium-ore"] = 1.5,
["time"] = 0.01,
["energy"] = 0.00001,
["water"] = 0.01,
["stone"] = 0.1,
["wood"] = 0.1,
}
price_modifier = {
["stone-brick"] = 50,
["stone-wall"] = 50,
["gate"] = 12,
["uranium-fuel-cell"] = 0.3,
["atomic-bomb"] = 0.4,
["modular-armor"] = 1.1,
["power-armor"] = 0.45,
["power-armor-mk2"] = 0.1,
["nuclear-reactor"] = 0.5,
["iron-plate"] = 5,
["copper-plate"] = 5,
["steel-plate"] = 4.7,
["sulfur"] = 2.7,
["dota-rocket-launcher"] = 1.2,
["explosives"] = 5,
["grenade"] = 2.5,
["fusion-reactor-equipment"] = 0.18,
["battery-mk2-equipment"] = 0.6,
["personal-roboport-mk2-equipment"] = 0.13,
["energy-shield-mk2-equipment"] = 0.75,
["personal-laser-defense-equipment"] = 0.65,
["discharge-defense-equipment"] = 0.6,
["exoskeleton-equipment"] = 0.8,
["rocket-fuel"] = 3,
["nuclear-fuel"] = 1.5,
["engine-unit"] = 5,
["electronic-circuit"] = 5,
["advanced-circuit"] = 5,
["processing-unit"] = 5,
["locomotive"] = 0.2,
["cargo-wagon"] = 0.2,
["fluid-wagon"] = 0.2,
["land-mine"] = 5,
--[] = 11
}
function styleitembutton(elem)
elem.style.top_margin = 0
elem.style.top_padding = 0
elem.style.left_margin = 0
elem.style.left_padding = 0
elem.style.right_margin = 0
elem.style.right_padding = 0
elem.style.bottom_margin = 0
elem.style.bottom_padding = 0
end
function fill_item_selector(box, player, group)
	for subgroupname, subgroup in pairs(global.itemselector[group]) do
		local i = 1
		local g = 1
		local subgroup = box.add{type = "flow", name = subgroupname.."-"..g, direction = "horizontal"}
		for itemname, item in pairs(global.itemselector[group][subgroupname]) do
			if player.force.recipes[global.database[itemname].recipe].enabled then
				if i > ITESEL_COLS then
					g=g+1
					i=1
					subgroup = box.add{type = "flow", name = subgroupname.."-"..g, direction = "horizontal"}
				end
				if global.database[itemname].type ~= "fluid" then
					i=i+1
					local button = subgroup.add{type="sprite-button", name = itemname, sprite = "item/"..itemname}
					styleitembutton(button)
					local price = 0
					for res_name, res_amount in pairs(global.database[itemname].raw) do
						if raw_prices[res_name] then
							price = price + raw_prices[res_name] *res_amount
						else
							price = price + 10000 *res_amount
						end
					end
					local old_price = price
					if price_modifier[itemname] then
						price = price * price_modifier[itemname]
					end
					if game.item_prototypes[itemname].type == "ammo" or game.item_prototypes[itemname].type == "gun" or game.item_prototypes[itemname].type == "item-with-entity-data" then
						price = price * 5
					elseif game.item_prototypes[itemname].type == "armor" then
						price = price * 2
					end
					if price ~= old_price then
						local mod = (price/old_price-1)*100
						if mod > 1 then
							mod = "+"..mod
						end
						local modifier_text = button.add{type="label", name = "price-modifier", caption = mod.."%"}
						local blue = math.min(1,old_price/price)
						if price < old_price then
							blue = math.min(1,price/old_price)
						end
						modifier_text.style.font_color = {r=math.min(1,price/old_price),g=math.min(1,old_price/price),b=blue}
						modifier_text.style.font = "default-tiny-bold"
					end

					button.number = price
				--else print(global.database[itemname].type)
				end
			--else print(itemname.." not enabled")
			end
		end
	end
end
function itemselector_gui(parent,player)
	if not global.itemselector then return end
	local elem
	local tabs = parent.add{type="flow", name= "itemgroups", direction="horizontal"}
	local firstgroup = nil
	for groupname,group in pairs(global.itemselector) do
		if groupname ~="fluids" then
			if not firstgroup then firstgroup = groupname end
			local temp = tabs.add{type="sprite-button", name = groupname, sprite = "item-group/"..groupname}
			temp.style.horizontally_stretchable = true
			temp.style.maximal_width = 100
		end
	end
	local box = parent.add{type="scroll-pane", name= "itemselector", direction="vertical"}
	fill_item_selector(box, player,firstgroup)

end
function format_money(money)
	formats = {["Y"] = 1000000000000000000000000,["Z"] = 1000000000000000000000,["E"] = 1000000000000000000,["P"] = 1000000000000000,["T"] = 1000000000000,["G"] = 1000000000, ["M"] = 1000000, ["K"] = 1000}
	if money >= 1000000000000000000000000000 then
		local e = 0
		while money >= 1000 do
			money = money/100
			e = e+2
		end
		return math.floor(money).."e"..e
	end
	for abbreviation, amount in pairs(formats) do
		if money >=amount then
			local decimals = math.floor((money-math.floor(money/amount)*amount)/amount*100)
			if decimals <10 then
				decimals = "0"..decimals
			end
			return math.floor(money/amount).."."..decimals..abbreviation
		end
	end
	local decimals = math.floor((money-math.floor(money))*100)
	if decimals <10 then
		decimals = "0"..decimals
	end
	return math.floor(money).."."..decimals
end

function guidefaults (elem)
	elem.style.top_margin  = -3
	elem.style.left_margin  = 0
	elem.style.right_margin  = 0
	elem.style.bottom_margin  = -3
	elem.style.left_padding  = 0
	elem.style.right_padding  = 0
	elem.style.top_padding  = 0
	elem.style.bottom_padding  = 0
end
function updatergui (player)
	if player.gui.top.dotamarket_updater then return end
	local gui = player.gui.top.add{type="frame", name= "dotamarket_updater", direction="vertical"}
		gui.style.width = 200
		gui.style.height = 45
		guidefaults(gui)
		gui.style.top_margin  = 4
	local header = gui.add{type="flow", name= "header", direction = "horizontal"}
		local title = header.add{type="label", name="title"}
			title.caption = "Updating prices..."
			title.style.font = "default-small"
			title.style.width = 175
			guidefaults(title)
			title.style.top_margin  = -4
		local pausebutton = header.add{type= "sprite-button",name = "dotamarket_pause"}
			pausebutton.style.height=15
			pausebutton.style.width=15
			guidefaults(pausebutton)
			pausebutton.style.top_margin=-2
			pausebutton.style.top_padding=0
			pausebutton.style.bottom_padding=0
			pausebutton.style.left_padding=0
			pausebutton.style.right_padding=0
			pausebutton.style.disabled_font_color ={r=1,g=1,b=1}
			if global.pauseupdate then
				pausebutton.sprite = "dotamarket_play"
			else
				pausebutton.sprite = "dotamarket_pause"
			end
	local bar = gui.add{type = "progressbar", name = "bar"}
		bar.value = global.updateprogress / global.totalrecipes
		bar.style.width = 192
		bar.style.height = 10
		guidefaults(bar)
	local current = "nil"
	for name, proto in pairs(game.recipe_prototypes) do
		current = proto.localised_name
		break
	end
	local numberflow = gui.add{type="flow", name= "numberflow", direction = "horizontal"}
		guidefaults(numberflow)
		numberflow.style.width = 200
		numberflow.add{type="label", name="current"}
			guidefaults(numberflow.current)
			numberflow.current.caption = current
			numberflow.current.style.width = 130
			numberflow.current.style.font = "default-small"
		--numberflow.add{type = "flow", name = "spacer"}
		--	numberflow.spacer.style.width = 135
		--	numberflow.spacer.style.horizontally_squashable = true
		numberflow.add{type="label", name="total"}
			guidefaults(numberflow.total)
			numberflow.total.caption = global.updateprogress.."/"..global.totalrecipes
			numberflow.total.style.width = 60
			numberflow.total.style.font = "default-small"
			numberflow.total.style.horizontal_align  = "right"
end

function crafting_gui(player)
	if not global.craftingguis[player.index] then
	 global.craftingguis[player.index] = {
		open_gui = false,
		sellinghistory = {},
		selling = false}
	end
	global.craftingguis[player.index].selling = false
	------
	local logistic_gap = 1200
	if (player.force.character_trash_slot_count >0) or (player.force.character_logistic_slot_count >0) then
		local slots = math.min(6,math.max(player.force.character_trash_slot_count,player.force.character_logistic_slot_count))
		logistic_gap = 1301
		if slots >2 then
			logistic_gap = logistic_gap+31
			logistic_gap = logistic_gap+(slots-3)*38
		end
	end
	------
	local gui=player.gui.center.add{type="frame", name= "owm-crafting", direction="vertical"}
		gui.style.right_margin  = logistic_gap
		gui.style.bottom_margin  = 100
		--gui.style.top_margin  = 30
		gui.style.width = 400
		gui.style.height = 400
	------
	local bar = gui.add{type="flow", name="bar", direction="horizontal"}
	local money = bar.add{type="label", name= "dotamarket_"..player.index, direction="vertical"}
	guidefaults(money)
	money.style.right_margin = -2
	money.caption = format_money(global.money[player.force.name])--"[img=dotamarket_washington] "..format_money(global.money[player.force.name])
	local money2 = bar.add{type="label", name= "dotamarket2_"..player.index, direction="vertical"}
	guidefaults(money2)
	money2.style.left_margin = -2
	money2.caption = "$"
	money2.style.font_color = {r=0,g=0.8,b=0}
	end
	function init_gui(player)
	if player.gui.top["dotamarket_"..player.index] then return end
	--local gui = player.gui.center.add{type="frame", name= "dotamarket_"..player.index, direction="vertical"}
	local button = player.gui.top.add{type="label", name= "dotamarket_"..player.index, direction="vertical"}
	button.caption = "[img=dotamarket_washington] "..format_money(global.money[player.force.name])
	button.style.top_margin  = 4
	button.style.left_margin  = 0
	button.style.left_padding  = 0
	button.style.right_padding  = 0
	button.style.top_padding  = 0
	button.style.bottom_padding  = 0
	button.style.height  = 36
	button.style.width  = 105--95
	button.style.font  = "heading-2"--"scenario-message-dialog"
	--button.style.font_color  = {r=0.2,g=0.2,b=0}
end

function item_gui(player,entity)
local elem
--player.gui.top.style.horizontally_squashable = false
--player.gui.top.style.horizontally_stretchable = true
local gui = player.gui.center.add{type="frame", name= "dotamarket_"..player.index, direction="vertical"}
	gui.style.width=500
	gui.style.height=200
	gui.style.bottom_margin  = 800
	gui.style.top_margin  = 30
--elem = gui.add{type= "sprite-button",name = "x"}
--		elem.style.height=20
--		elem.style.width=20
--		elem.style.top_padding=0
--		elem.style.bottom_padding=0
--		elem.style.left_padding=0
--		elem.style.right_padding=0
--		--elem.style.disabled_font_color ={r=1,g=1,b=1}
--		elem.sprite="dotamarket_close"
--local market_flow = gui.add{type= "flow",name = "selection_flow", direction = "horizontal"}
local selection_flow = gui.add{type= "flow",name = "selection_flow", direction = "horizontal"}
elem = selection_flow.add{type= "choose-elem-button",name = "item_selector",elem_type = "recipe"}
	elem.style.width = 50
	elem.style.height = 50
local parameters_flow = selection_flow.add{type= "flow",name = "parameters_flow", direction = "vertical"}
local price_flow = parameters_flow.add{type= "flow",name = "price_flow"}
	elem = price_flow.add{type= "label",name = "price_caption"}
		elem.caption = "Max. Price"
		elem.style.width = 70
	elem = price_flow.add{type= "slider",name = "price_selector"}
		elem.style.top_margin=7
	elem = price_flow.add{type= "textfield",name = "price_field"}
		elem.style.width = 60
		elem.style.height = 25
local amount_flow = parameters_flow.add{type= "flow",name = "amount_flow"}
	elem = amount_flow.add{type= "label",name = "amount_caption"}
		elem.caption = "Fill up to.."
		elem.style.width = 70
	elem = amount_flow.add{type= "slider",name = "amount_selector"}
		elem.style.top_margin=7
	elem = amount_flow.add{type= "textfield",name = "amount_field"}
	elem.style.width = 60
	elem.style.height = 25
	--gui.style.horizontally_stretchable  = true
	--gui.style.horizontally_squashable = false
	--gui.style.horizontal_align ="center"
	
--elem = gui.add{type="frame", name= "dotamarket_topframe_"..player.index, direction="vertical"}
--	elem.style.horizontal_align ="center"
end

function fluid_gui(player,entity,mode)
if player.gui.center["dotamarket_fluid_"..player.index] then
	player.gui.center["dotamarket_fluid_"..player.index].destroy()
end
local elem
--player.gui.top.style.horizontally_squashable = false
--player.gui.top.style.horizontally_stretchable = true
local gui = player.gui.center.add{type="frame", name= "dotamarket_fluid_"..player.index, direction="vertical"}
	gui.style.width=500
	gui.style.height=200
	--gui.style.bottom_margin  = 800
	--gui.style.top_margin  = 30
--elem = gui.add{type= "sprite-button",name = "x"}
--		elem.style.height=20
--		elem.style.width=20
--		elem.style.top_padding=0
--		elem.style.bottom_padding=0
--		elem.style.left_padding=0
--		elem.style.right_padding=0
--		--elem.style.disabled_font_color ={r=1,g=1,b=1}
--		elem.sprite="dotamarket_close"
--local market_flow = gui.add{type= "flow",name = "selection_flow", direction = "horizontal"}
local selection_flow = gui.add{type= "flow",name = "selection_flow", direction = "horizontal"}
elem = selection_flow.add{type= "choose-elem-button",name = "item_selector",elem_type = "recipe"}
	elem.style.width = 50
	elem.style.height = 50
local parameters_flow = selection_flow.add{type= "flow",name = "parameters_flow", direction = "vertical"}
local price_flow = parameters_flow.add{type= "flow",name = "price_flow"}
	elem = price_flow.add{type= "label",name = "price_caption"}
		elem.caption = "Max. Price"
		elem.style.width = 70
	elem = price_flow.add{type= "slider",name = "price_selector"}
		elem.style.top_margin=7
	elem = price_flow.add{type= "textfield",name = "price_field"}
		elem.style.width = 60
		elem.style.height = 25
local amount_flow = parameters_flow.add{type= "flow",name = "amount_flow"}
	elem = amount_flow.add{type= "label",name = "amount_caption"}
		elem.caption = "Fill up to.."
		elem.style.width = 70
	elem = amount_flow.add{type= "slider",name = "amount_selector"}
		elem.style.top_margin=7
	elem = amount_flow.add{type= "textfield",name = "amount_field"}
	elem.style.width = 60
	elem.style.height = 25
	--gui.style.horizontally_stretchable  = true
	--gui.style.horizontally_squashable = false
	--gui.style.horizontal_align ="center"
	player.opened = gui
--elem = gui.add{type="frame", name= "dotamarket_topframe_"..player.index, direction="vertical"}
--	elem.style.horizontal_align ="center"
end